<id>
Quick Reply Advanced Edition V1.3 for YaBB 2.2.2
</id>

<version>
1.3
</version>

<mod info>
This mod allows user to post quickly a reply or post.

Installation:
1) Move post.js from yabbfiles to cgi-bin/yabb2/ for installing with Boardmod.
2) Modify YaBB files using BoardMod or manually.
3) Load modified files to your server in ASCII mode.  
 
/Admin/ModList.pl (ASCII)
/Admin/NewSettings.pl (ASCII)
/Admin/Settings_Main.pl (ASCII)
/Languages/English/Admin.lng (ASCII)
/Languages/English/Display.lng (ASCII)
/Languages/English/Menu.lng (ASCII)
/Languages/English/Post.lng (ASCII)
/Sources/Display.pl (ASCII)
/Sources/MessageIndex.pl (ASCII)
/Sources/Post.pl (ASCII)
/Variables/Menu0.def (ASCII)
/Variables/Menu1.def (ASCII)
/Variables/Menu2.def (ASCII)

/yabbfiles/post.js (ASCII)

From Package:
/yabbfiles/Buttons/English/mark_quote.png (Binary)
/yabbfiles/Templates/Forum/default/mark_quote.gif (Binary)
/yabbfiles/Templates/Forum/default/qquname.gif (Binary)

Note: If you had Quick Reply 1.3 installed. Delete following unused files from your Server:

/Admin/QuickReply.pl
/Languages/English/QuickReply.lng

Dont forgot - after uninstalling Quick Reply 1.3, re-upload the following files after unmodding:

/YaBB.pl (ASCII)
/AdminIndex.pl (ASCII)
/Admin/AdminSubList.pl (ASCII)
/Templates/default/Display.template (ASCII)
/Templates/yabb21/Display.template (ASCII)

/yabbfiles/post.js (ASCII)

Mod History:
Status Quick Reply Advanced Edition V1.3 ( June 05th 2008 )
- Updated for YaBB 2.2.2

Status Quick Reply Advanced Edition V1.2 ( April 27th 2008 )
- Fix to show Attachment Box on Quick Post/Reply

Status Quick Reply Advanced Edition V1.1 ( March 30th 2008 )
- Fix Show username displaying "replying" instead "viewing" to a Topic if Quick Reply is enabled

Status Quick Reply Advanced Edition V1.0 ( March 23rd  2008 )
- First Release of Rewriting and include Mark & Quote with User Quote (before named as Quick-Quote) for YaBB 2.2.1
</mod info>

<author>
Jeffrey Man (Jet Li) and Detlef Pilzecker (deti)
</author>

<homepage>
http://www.yabbworld.com
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$advquickreply = "Quick_Reply_Advanced_Edition|Jeffrey Man (<a href=\"http://www.yabbworld.com\" target=\"_blank\">Jet Li</a>) and Detlef Pilzecker (deti)|This mod allows user to post quickly a reply or post.|1.3|June 05th, 2008";
	push (@installed_mods, "$advquickreply");
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$ML_Allowed = $ML_Allowed;				# allow browse MemberList

</search for>

<add after>
########## Quick Reply configuration ##########
\$enable_quickpost = $enable_quickpost;			 # Set to 1 if you want to enable the quick post box
\$enable_quickreply = $enable_quickreply;		     # Set to 1 if you want to enable the quick reply box
\$enable_quickjump = $enable_quickjump;			 # Set to 1 if you want to enable the jump to quick reply box
\$enable_markquote = $enable_markquote;			 # Set to 1 if you want to enable the mark&quote feature
\$quick_quotelength = $quick_quotelength;		     # Set the max length for Quick Quotes
\$enable_quoteuser = $enable_quoteuser;			 # Set to 1 if you want to enable userquote
\$quoteuser_color = "$quoteuser_color";			 # Set the default color of @ in userquote
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
		{
			description => $polltxt{'60'},
			input_html => qq~<input type="checkbox" name="ubbcpolls" value="1"${ischecked($ubbcpolls)} />~,
			name => 'ubbcpolls',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			header => $qrb_txt{'1'},
		},
		{
			description => $qrb_txt{'2'},
			input_html => qq~<input type="checkbox" name="enable_quickpost" value="1"${ischecked($enable_quickpost)} />~,
			name => 'enable_quickpost',
			validate => 'boolean',
		},
		{
			description => $qrb_txt{'3'},
			input_html => qq~<input type="checkbox" name="enable_quickreply" value="1"${ischecked($enable_quickreply)} />~,
			name => 'enable_quickreply',
			validate => 'boolean',
		},
		{
			description => $qrb_txt{'4'},
			input_html => qq~<input type="checkbox" name="enable_markquote" value="1"${ischecked($enable_markquote)} />~,
			name => 'enable_markquote',
			validate => 'boolean',
		},
		{
			description => $qrb_txt{'5'},
			input_html => qq~<input type="checkbox" name="enable_quoteuser" value="1"${ischecked($enable_quoteuser)} />~,
			name => 'enable_quoteuser',
			validate => 'boolean',
		},
		{
			description => $qrb_txt{'6'},
			input_html => qq~<input type="text" size="6" maxlength="7" name="quoteuser_color" value="$quoteuser_color" /> <img src="$imagesdir/palette1.gif" style="cursor: pointer" onclick="window.open('$scripturl?action=palette;task=templ', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no')" alt="" border="0" />
			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function previewColor(color) {
				   document.getElementsByName("quoteuser_color")[0].value = color;
			}
			//-->
			</script>~,
			name => 'quoteuser_color',
			validate => 'text',
		},
		{
			description => $qrb_txt{'7'},
			input_html => qq~<input type="checkbox" name="enable_quickjump" value="1"${ischecked($enable_quickjump)} />~,
			name => 'enable_quickjump',
			validate => 'boolean',
		},
		{
			description => $qrb_txt{'8'},
			input_html => qq~<input type="text" size="5" name="quick_quotelength" value="$quick_quotelength" />~,
			name => 'quick_quotelength',
			validate => 'number',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
%polltxt = (
'28' => 'Number of Poll Options:',
'29' => 'Allow Users to add Polls to existing Topics?',
'60' => 'Allow UBBC tags and Smilies in Polls?',
'61' => 'Maximum number of Characters in a Poll Question:',
'62' => 'Maximum number of Characters in a Poll Option:',
'63' => 'Maximum number of Characters in a Poll Comment (Set to 0 to disable):',
'64' => 'Polls',
);

</search for>

<add after>
%qrb_txt = (
'1' => 'Quick Post / Reply Box',
'2' => 'Enable Quick Post Box?',
'3' => 'Enable Quick Reply Box?',
'4' => 'Enable <i>Mark &amp; Quote</i>?<br /><span class="small">(If Quick Reply Box is enabled.)</span>',
'5' => "Enable <i>UserQuote</i> (<font color='$quoteuser_color'>@</font> <i><b>username</b></i>)?<br /><span class='small'>(If Quick Reply Box is enabled.)</span>",
'6' => 'Set the color of @ in <i>UserQuote</i> (example: "red" or "#FF0000"):<br /><span class="small">(If <i>UserQuote</i> is enabled.)</span>',
'7' => 'Enable Jump-To Quick- Post/Reply-Box when clicking on <i>Start New Topic</i>, <i>Reply</i> or <i>Quote</i>?<br /><span class="small">(If Quick Post/Reply Box is enabled.)</span>',
'8' => 'Max length for Quote:<br /><span class="small">(If Jump-To Quick- Post/Reply-Box is enabled.)<br />2000 => means that messages longer than 2000 characters will be Quoted NOT using the Quick-Reply-Box but the dafault Quotepage. This way the upload volume can be limited!</span>',
);

</add after>

<edit file>
Languages/English/Display.lng
</edit file>

<search for>
'146' => 'Reply',
</search for>

<add after>
'146n' => 'Paste User Name in Quick Reply Box',
</add after>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
'145' => 'Quote',
</search for>

<add after>
'145q' => 'Mark & Quote',
</add after>

<edit file>
Languages/English/Post.lng
</edit file>

<search for>
'textsize' => 'Text size:',
</search for>

<add after>
'alertquote' => 'To use Quote mark the text of this user.',
'quote_confirm' => 'If you want to cite this contribution, and you click OK, then your records in the response textbox below will get lost. If you do not want this, then click Cancel, then copy your records before you click OK next time. Than you can insert your records again on the next page.',
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		$replybutton = qq~$menusep<a href="$scripturl?action=post;num=$viewnum;title=PostReply">$img{'reply'}</a> ~;
</search for>

<replace>
		$replybutton = qq~$menusep<a href="~ . ($enable_quickreply && $enable_quickjump ? 'javascript:document.postmodify.message.focus();' : qq~$scripturl?action=post;num=$viewnum;title=PostReply~) . qq~">$img{'reply'}</a> ~;
</replace>

<search for>
				$template_quote = qq~$menusep<a href="$scripturl?action=post;num=$viewnum;quote=$counter;title=PostReply">$img{'quote'}</a>~;
</search for>

<replace>
			my $quote_mname = $mname;
			$quote_mname =~ s/'/\\'/g;
			$usernamelink = qq~<a href="javascript:void(AddText('[color=$quoteuser_color]@[/color]&nbsp;[b]$quote_mname\[/b]\\r\\n\\r\\n'))"><img src="$defaultimagesdir/qquname.gif" border="0" alt="$display_txt{'146n'}" /></a>&nbsp;$usernamelink~ if $enable_quickreply && $enable_quoteuser;

			if ($enable_quickreply) {
				if ($enable_markquote) {
				    $outblock =~ s/(<div)( class="$messageclass" style="float: left; width: 99%; overflow: auto;">)/$1 onMouseup="get_selection($counter);"$2/i;
				    $template_quote = qq~$menusep<a href="javascript:void(quoteSelection('$quote_mname',$viewnum,$counter,$mdate,''))">$img{'mquote'}</a>~;
				    } else {
				    $template_quote = '';
				    }
				    if ($enable_quickjump) {
				        if (length($postmessage) <= $quick_quotelength) {
				            my $message = $postmessage;
				            $message =~ s/<(br|p).*?>/\\r\\n/ig;
				            $message =~ s/'/\\'/g;
				            $template_quote .= qq~$menusep<a href="javascript:void(quoteSelection('$quote_mname',$viewnum,$counter,$mdate,'$message'))">$img{'quote'}</a>~;
				        } else {
				            $template_quote .= qq~$menusep<a href="javascript:void(quick_quote_confirm('$scripturl?action=post;num=$viewnum;quote=$counter;title=PostReply'))">$img{'quote'}</a>~;
				        }
				    } else {
				        $template_quote .= qq~$menusep<a href="$scripturl?action=post;num=$viewnum;quote=$counter;title=PostReply">$img{'quote'}</a>~;
				    }
			} else {
			    $template_quote = qq~$menusep<a href="$scripturl?action=post;num=$viewnum;quote=$counter;title=PostReply">$img{'quote'}</a>~;
			}
</replace>

<search for>
	$yytitle = $msubthread;
</search for>

<add after>
if ($replybutton and $enable_quickreply) {
	require "$sourcedir/Post.pl";
	$action = 'post';
	$INFO{'title'} = 'PostReply';
	$Quick_Post = 1;
	$message = '';
	&Post;
}
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	$yytitle = $boardname;
</search for>

<add after>
if ($postlink and $enable_quickpost) {
	require "$sourcedir/Post.pl";
	$action = 'post';
	$INFO{'title'} = 'StartNewTopic';
	$Quick_Post = 1;
	&Post;
}
</add after>

<search for>
		$postlink = qq~$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=StartNewTopic">$img{'newthread'}</a>~;
</search for>

<replace>
		$postlink = qq~$menusep<a href="~ . ($enable_quickpost && $enable_quickjump ? 'javascript:document.postmodify.message.focus();' : qq~$scripturl?board=$INFO{'board'};action=post;title=StartNewTopic~) . qq~">$img{'newthread'}</a>~;
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	if ($postthread == 2 && $username ne "Guest") {
</search for>

<replace>
	if (!$Quick_Post && $postthread == 2 && $username ne "Guest") {
</replace>

<search for>
	$preview     = "preview";
	$yytitle     = "$t_title";
	&Postpage;
	&doshowthread;
</search for>

<replace>
	$preview     = "preview";
	$yytitle     = "$t_title"  unless $Quick_Post;
	&Postpage;
	&doshowthread  unless $Quick_Post;
</replace>

<search for>
	if ($destination ne 'modalert2' && $destination ne 'guestpm2') {
</search for>

<replace>
	if ($destination ne 'modalert2' && $destination ne 'guestpm2' && !$Quick_Post) {
</replace>

<search for>
		$yynavigation = qq~&rsaquo; <a href="$scripturl?catselect=$catid" class="nav">$cat</a> &rsaquo; <a href="$scripturl?board=$currentboard" class="nav">$boardname</a> &rsaquo; $t_title ( $threadlink )~;
	} else {
		$yynavigation = qq~&rsaquo; $t_title~;
</search for>

<replace>
		$yynavigation = qq~&rsaquo; <a href="$scripturl?catselect=$catid" class="nav">$cat</a> &rsaquo; <a href="$scripturl?board=$currentboard" class="nav">$boardname</a> &rsaquo; $t_title ( $threadlink )~;
	} elsif (!$Quick_Post) {
		$yynavigation = qq~&rsaquo; $t_title~;
</replace>

<search for>
	#this is the end of the upper area of the post page.
	$yymain .= qq~
<script language="JavaScript1.2" src="$postjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
var postas = '$post';
var namefield = '$realname';
var mailfield = '$realemail';
</search for>

<replace>
	#this is the end of the upper area of the post page.
	$yymain .= qq~
<script language="JavaScript1.2" src="$postjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--

function alertqq() {
	   alert("$post_txt{'alertquote'}");
}
function quick_quote_confirm(ahref) {
	   if (document.postmodify.message.value == "") {
		 window.location.href = ahref;
	   }  else {
		 var Check = confirm('$post_txt{'quote_confirm'}');
		 if (Check == true) {
		     window.location.href = ahref;
		 } else {
		     document.postmodify.message.focus();
		 }
	   }
}

var postas = '$post';
var namefield = '$realname';
var mailfield = '$realemail';
</replace>

<search for>
	if ($postthread == 2 && $showtopicrepliers && (($iamadmin || $iamgmod || $iammod) && $sessionvalid == 1)) {
</search for>

<replace>
	if (!$Quick_Post && $postthread == 2 && $showtopicrepliers && (($iamadmin || $iamgmod || $iammod) && $sessionvalid == 1)) {
</replace>

<search for>
document.postmodify.$settofield.focus();
</search for>

<replace>
~ . (!$Quick_Post ? "document.postmodify.$settofield.focus();" : "") . qq~
</replace>

<search for>
			unless ($message eq '') {
				$yymain .= qq~
<tr><td align="left" class="catbg">
<span class="small">$post_txt{'279'}: $displaynamelink</span></td>
<td class="catbg" align="right">
<span class="small">$post_txt{'280'}: $tempdate</span></td>
</tr>
<tr><td class="windowbg2" colspan="2">
<div style="max-height: 150px; overflow: auto;">
$message
</div>
</td></tr>~;
</search for>

<replace>
			my $quote_mname = $temprname;
			$quote_mname =~ s/'/\\'/g;
			my $quote_msg_id = $tsreverse == 1 ? (@messages - $amounter -1) : $amounter;
			unless ($message eq '') {
				$yymain .= qq~

<tr><td align="left" class="catbg">
<span class="small">$post_txt{'279'}: $displaynamelink~ . ($enable_markquote ? qq~&nbsp;&nbsp;<a href="javascript:void(quoteSelection('$quote_mname',$threadid,$quote_msg_id,$messagedate,''))">$img{'mquote'}</a>~ : '') . qq~</span></td>
<td class="catbg" align="right">
<span class="small">$post_txt{'280'}: $tempdate</span></td>
</tr>
<tr><td class="windowbg2" colspan="2">
<div onMouseup="get_selection($quote_msg_id);" style="max-height: 150px; overflow: auto;">
$message
</div>
</td></tr>~;
</replace>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
'quote' => "<img src=\"$imagesdir/quote.$imgext\" alt=\"$img_txt{'145'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'145'}</span>",
</search for>

<add after>
'mquote' => "<img src=\"$imagesdir/mark_quote.$imgext\" alt=\"$img_txt{'145q'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'145q'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
'quote' => "<span class=\"imgwindowbg\">$img_txt{'145'}</span>",
</search for>

<add after>
'mquote' => "<span class=\"imgwindowbg\">$img_txt{'145q'}</span>",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
'quote' => "<img src=\"$html_root/Buttons/$button_language/quote.$imgext\" alt=\"$img_txt{'145'}\" border=\"0\" />",
</search for>

<add after>
'mquote' => "<img src=\"$html_root/Buttons/$button_language/mark_quote.$imgext\" alt=\"$img_txt{'145q'}\" border=\"0\" />",
</add after>

<edit file>
post.js
</edit file>

<search for>
function selectNewattach() {
	document.getElementById("w_file").options[1].selected = true;
}

</search for>

<add after>
var quote_selection = new Array();

function quoteSelection(quote_name, quote_topic_id, quote_msg_id, quote_date, quote_message) {
	   if ((quote_selection[quote_msg_id] && quote_selection[quote_msg_id] != '') || quote_message != '') {
		 if (quote_message) quote_selection[quote_msg_id] = quote_message;
		 AddText('[quote author=' + quote_name + ' link=' + quote_topic_id + '/' + quote_msg_id + '#' + quote_msg_id + ' date=' + quote_date + ']' + quote_selection[quote_msg_id] + ' [/quote]\r\n');
		 quote_selection[quote_msg_id] = '';
		 quote_message = '';
	   } else {
		 alertqq();
	   }
}

function get_selection(msg_id) {
	   if (document.getSelection) {
		 quote_selection[msg_id] = document.getSelection();
	   } else {
		 quote_selection[msg_id] = document.selection.createRange().text;
	   }
	   quote_selection[msg_id] = '' + quote_selection[msg_id] + '';
	  // quote_selection[msg_id] = quote_selection[msg_id].replace(/\\r\\n/g, "_caret_");
	   while (quote_selection[msg_id].indexOf("  ") != -1) quote_selection[msg_id] = quote_selection[msg_id].replace(/  /gi, "");
	  // quote_selection[msg_id] = quote_selection[msg_id].replace(/_caret_/g, "\\r\\n");
}
</add after>